Project Chrono: chrono::fea::ChElementShellANCF_3423 Class Reference

Classes | Public Types | Public Member Functions | Static Public Attributes | Friends | List of all members
chrono::fea::ChElementShellANCF_3423 Class Reference
Chrono::Engine » Finite Element Analysis » Elements

## Description

ANCF laminated shell element with four nodes.

This class implements composite material elastic force formulations.

The node numbering is in ccw fashion as in the following scheme:

            v
            ^
            |
    D o-----+-----o C
      |     |     |
    --+-----+-----+----> u
      |     |     |
    A o-----+-----o B

`#include <ChElementShellANCF_3423.h>`

Inheritance diagram for chrono::fea::ChElementShellANCF_3423:
[legend]
Collaboration diagram for chrono::fea::ChElementShellANCF_3423:
[legend]

## Classes
class | Layer
| Definition of a layer. More...

## Public Types
using | ShapeVector = ChMatrixNM<double, 1, NSF>
using | VectorN = ChVectorN<double, NSF>
using | MatrixNx3 = ChMatrixNM<double, NSF, 3>

## Public Member Functions
virtual unsigned int | GetNumNodes () override
| Get the number of nodes used by this element.
virtual unsigned int | GetNumCoordsPosLevel () override
| Get the number of coordinates in the field used by the referenced nodes.
virtual unsigned int | GetNumCoordsPosLevelActive () override
| Get the number of active coordinates in the field used by the referenced nodes.
virtual unsigned int | GetNodeNumCoordsPosLevel (unsigned int n) override
| Get the number of coordinates from the n-th node used by this element.
virtual unsigned int | GetNodeNumCoordsPosLevelActive (unsigned int n) override
| Get the number of active coordinates from the n-th node used by this element.
void | SetNodes (std::shared_ptr< ChNodeFEAxyzD > nodeA, std::shared_ptr< ChNodeFEAxyzD > nodeB, std::shared_ptr< ChNodeFEAxyzD > nodeC, std::shared_ptr< ChNodeFEAxyzD > nodeD)
| Specify the nodes of this element.
void | SetDimensions (double lenX, double lenY)
| Specify the element dimensions.
virtual std::shared_ptr< ChNodeFEAbase > | GetNode (unsigned int n) override
| Access the n-th node of this element.
std::shared_ptr< ChNodeFEAxyzD > | GetNodeA () const
| Get a handle to the first node of this element.
std::shared_ptr< ChNodeFEAxyzD > | GetNodeB () const
| Get a handle to the second node of this element.
std::shared_ptr< ChNodeFEAxyzD > | GetNodeC () const
| Get a handle to the third node of this element.
std::shared_ptr< ChNodeFEAxyzD > | GetNodeD () const
| Get a handle to the fourth node of this element.
void | AddLayer (double thickness, double theta, std::shared_ptr< ChMaterialShellANCF > material)
| Add a layer.
size_t | GetNumLayers () const
| Get the number of layers.
const Layer & | GetLayer (size_t i) const
| Get a handle to the specified layer.
void | SetAlphaDamp (double a)
| Set the structural damping.
double | GetLengthX () const
| Get the element length in the X direction.
double | GetLengthY () const
| Get the element length in the Y direction.
double | GetThickness ()
| Get the total thickness of the shell element.
void | ShapeFunctions (ShapeVector &N, double x, double y, double z)
| Fills the N shape function matrix.
void | ShapeFunctionsDerivativeX (ShapeVector &Nx, double x, double y, double z)
| Fills the Nx shape function derivative matrix with respect to X.
void | ShapeFunctionsDerivativeY (ShapeVector &Ny, double x, double y, double z)
| Fills the Ny shape function derivative matrix with respect to Y.
void | ShapeFunctionsDerivativeZ (ShapeVector &Nz, double x, double y, double z)
| Fills the Nz shape function derivative matrix with respect to Z.
ChStrainStress3D | EvaluateSectionStrainStress (const ChVector3d &loc, int layer_id)
| Return a struct with 6-component strain and stress vectors evaluated at a given quadrature point and layer number.
void | EvaluateDeflection (double &defVec)
virtual void | GetStateBlock (ChVectorDynamic<> &mD) override
| Fill the D vector with the current field values at the nodes of the element, with proper ordering.
virtual void | ComputeKRMmatricesGlobal (ChMatrixRef H, double Kfactor, double Rfactor=0, double Mfactor=0) override
| Set H as the stiffness matrix K, scaled by Kfactor.
virtual void | ComputeMmatrixGlobal (ChMatrixRef M) override
| Set M as the global mass matrix.
virtual void | ComputeNodalMass () override
| Add contribution of element inertia to total nodal masses.
virtual void | ComputeGravityForces (ChVectorDynamic<> &Fg, const ChVector3d &G_acc) override
| Compute the generalized force vector due to gravity using the efficient ANCF specific method.
virtual void | ComputeInternalForces (ChVectorDynamic<> &Fi) override
| Computes the internal forces.
virtual void | Update () override
| Update the state of this element.
virtual void | EvaluateSectionDisplacement (const double u, const double v, ChVector3d &u_displ, ChVector3d &u_rotaz) override
| Gets the xyz displacement of a point on the shell, and the rotation RxRyRz of section reference, at parametric coordinates 'u' and 'v'.
virtual void | EvaluateSectionFrame (const double u, const double v, ChVector3d &point, ChQuaternion<> &rot) override
| Gets the absolute xyz position of a point on the shell, and the absolute rotation of section reference, at parametric coordinates 'u' and 'v'.
virtual void | EvaluateSectionPoint (const double u, const double v, ChVector3d &point) override
| Gets the absolute xyz position of a point on the shell, at parametric coordinates 'u' and 'v'.
void | ComputeInternalJacobians (double Kfactor, double Rfactor)
| Compute Jacobians of the internal forces.
void | ComputeMassMatrix ()
| Compute the mass matrix of the element.
void | ComputeGravityForceScale ()
| Compute the matrix to scale gravity by to get the generalized gravitational force.
void | ShapeFunctionANSbilinearShell (ChMatrixNM< double, 1, 4 > &S_ANS, double x, double y)
void | CalcStrainANSbilinearShell ()
void | Basis_M (ChMatrixNM< double, 6, 5 > &M, double x, double y, double z)
double | Calc_detJ0 (double x, double y, double z)
double | Calc_detJ0 (double x, double y, double z, ShapeVector &Nx, ShapeVector &Ny, ShapeVector &Nz, ChMatrixNM< double, 1, 3 > &Nx_d0, ChMatrixNM< double, 1, 3 > &Ny_d0, ChMatrixNM< double, 1, 3 > &Nz_d0)
void | CalcCoordMatrix (ChMatrixNM< double, 8, 3 > &d)
void | CalcCoordDtMatrix (ChVectorN< double, 24 > &dt)
virtual unsigned int | GetLoadableNumCoordsPosLevel () override
| Gets the number of DOFs affected by this element (position part).
virtual unsigned int | GetLoadableNumCoordsVelLevel () override
| Gets the number of DOFs affected by this element (velocity part).
virtual void | LoadableGetStateBlockPosLevel (int block_offset, ChState &mD) override
| Gets all the DOFs packed in a single vector (position part).
virtual void | LoadableGetStateBlockVelLevel (int block_offset, ChStateDelta &mD) override
| Gets all the DOFs packed in a single vector (velocity part).
virtual void | LoadableStateIncrement (const unsigned int off_x, ChState &x_new, const ChState &x, const unsigned int off_v, const ChStateDelta &Dv) override
| Increment all DOFs using a delta.
virtual unsigned int | GetNumFieldCoords () override
| Number of coordinates in the interpolated field, ex=3 for a tetrahedron finite element or a cable, = 1 for a thermal problem, etc.
virtual unsigned int | GetNumSubBlocks () override
| Get the number of DOFs sub-blocks.
virtual unsigned int | GetSubBlockOffset (unsigned int nblock) override
| Get the offset of the specified sub-block of DOFs in global vector.
virtual unsigned int | GetSubBlockSize (unsigned int nblock) override
| Get the size of the specified sub-block of DOFs in global vector.
virtual bool | IsSubBlockActive (unsigned int nblock) const override
| Check if the specified sub-block of DOFs is active.
virtual void | EvaluateSectionVelNorm (double U, double V, ChVector3d &Result) override
| Virtual method to plot velocity field distribution.
virtual void | LoadableGetVariables (std::vector< ChVariables * > &mvars) override
| Get the pointers to the contained ChVariables, appending to the mvars vector.
virtual void | ComputeNF (const double U, const double V, ChVectorDynamic<> &Qi, double &detJ, const ChVectorDynamic<> &F, ChVectorDynamic<> *state_x, ChVectorDynamic<> *state_w) override
| Evaluate N'*F , where N is some type of shape function evaluated at U,V coordinates of the surface, each ranging in -1..+1 F is a load, N'*F is the resulting generalized load Returns also det[J] with J=[dx/du,..], that might be useful in gauss quadrature.
virtual void | ComputeNF (const double U, const double V, const double W, ChVectorDynamic<> &Qi, double &detJ, const ChVectorDynamic<> &F, ChVectorDynamic<> *state_x, ChVectorDynamic<> *state_w) override
| Evaluate N'*F , where N is some type of shape function evaluated at U,V,W coordinates of the volume, each ranging in -1..+1 F is a load, N'*F is the resulting generalized load Returns also det[J] with J=[dx/du,..], that might be useful in gauss quadrature.
virtual double | GetDensity () override
| This is needed so that it can be accessed by ChLoaderVolumeGravity.
virtual ChVector3d | ComputeNormal (const double U, const double V) override
| Gets the normal to the surface at the parametric coordinate U,V.
Public Member Functions inherited from chrono::fea::ChElementShell
virtual bool | IsTriangleShell ()
| Return false if quadrilateral shell - hence u,v parametric coordinates assumed in -1..+1, return true if triangular shell - hence u,v are triangle natural coordinates assumed in 0..+1.
Public Member Functions inherited from chrono::fea::ChElementGeneric
ChKRMBlock & | Kstiffness ()
| Access the proxy to stiffness, for sparse solver.
virtual void | EleIntLoadResidual_F (ChVectorDynamic<> &R, const double c) override
| Add the internal forces (pasted at global nodes offsets) into a global vector R, multiplied by a scaling factor c, as R += forces * c This default implementation is SLIGHTLY INEFFICIENT.
virtual void | EleIntLoadResidual_Mv (ChVectorDynamic<> &R, const ChVectorDynamic<> &w, const double c) override
| Add the product of element mass M by a vector w (pasted at global nodes offsets) into a global vector R, multiplied by a scaling factor c, as R += M * w * c This default implementation is VERY INEFFICIENT.
virtual void | EleIntLoadLumpedMass_Md (ChVectorDynamic<> &Md, double &error, const double c) override
| Adds the lumped mass to a Md vector, representing a mass diagonal matrix.
virtual void | EleIntLoadResidual_F_gravity (ChVectorDynamic<> &R, const ChVector3d &G_acc, const double c) override
| Add the contribution of gravity loads, multiplied by a scaling factor c, as: R += M * g * c This default implementation is VERY INEFFICIENT.
virtual void | InjectKRMMatrices (ChSystemDescriptor &descriptor) override
| Register with the given system descriptor any ChKRMBlock objects associated with this item.
virtual void | LoadKRMMatrices (double Kfactor, double Rfactor, double Mfactor) override
| Compute and load current stiffnes (K), damping (R), and mass (M) matrices in encapsulated ChKRMBlock objects.
virtual void | VariablesFbLoadInternalForces (double factor=1.) override
| Add the internal forces, expressed as nodal forces, into the encapsulated ChVariables.
virtual void | VariablesFbIncrementMq () override
| Add M*q (internal masses multiplied current 'qb').
Public Member Functions inherited from chrono::fea::ChElementBase
virtual void | EleDoIntegration ()
| This is optionally implemented if there is some internal state that requires integration.
Public Member Functions inherited from chrono::ChLoadableUV
virtual bool | IsTriangleIntegrationNeeded ()
| If true, use quadrature over u,v in [0..1] range as triangle area coords (with z=1-u-v) otherwise use default quadrature over u,v in [-1..+1] as rectangular isoparametric coords.
Public Member Functions inherited from chrono::ChLoadableUVW
virtual bool | IsTetrahedronIntegrationNeeded ()
| If true, use quadrature over u,v,w in [0..1] range as tetrahedron volumetric coords (with z=1-u-v-w) otherwise use default quadrature over u,v,w in [-1..+1] as box isoparametric coords.
virtual bool | IsTrianglePrismIntegrationNeeded ()
| If true, use quadrature over u,v in [0..1] range as triangle natural coords (with z=1-u-v), and use linear quadrature over w in [-1..+1], otherwise use default quadrature over u,v,w in [-1..+1] as box isoparametric coords.

## Static Public Attributes
static const int | NSF = 8
| number of shape functions

## Friends
class | ShellANCF_Mass
class | ShellANCF_Gravity
class | ShellANCF_Force
class | ShellANCF_Jacobian

## Additional Inherited Members
Protected Attributes inherited from chrono::fea::ChElementANCF
int | m_element_dof
| actual number of degrees of freedom for the element
bool | m_full_dof
| true if all node variables are active (not fixed)
ChArray< int > | m_mapping_dof
| indices of active DOFs (set only is some are fixed)
Protected Attributes inherited from chrono::fea::ChElementShell
double | mass
Protected Attributes inherited from chrono::fea::ChElementGeneric
ChKRMBlock | Kmatr

## Member Function Documentation

## ◆ AddLayer()

void chrono::fea::ChElementShellANCF_3423::AddLayer | ( | double | thickness,
|  | double | theta,
|  | std::shared_ptr< ChMaterialShellANCF > | material )

Add a layer.

Parameters

  thickness | layer thickness
  theta | fiber angle (radians)
  material | layer material

## ◆ ComputeGravityForces()

void chrono::fea::ChElementShellANCF_3423::ComputeGravityForces | ( | ChVectorDynamic<> & | Fg,
|  | const ChVector3d & | G_acc )
| overridevirtual

Compute the generalized force vector due to gravity using the efficient ANCF specific method.

Reimplemented from chrono::fea::ChElementGeneric.

## ◆ ComputeInternalForces()

void chrono::fea::ChElementShellANCF_3423::ComputeInternalForces | ( | ChVectorDynamic<> & | Fi | ) |
| overridevirtual

Computes the internal forces.

(E.g. the actual position of nodes is not in relaxed reference position) and set values in the Fi vector.

Implements chrono::fea::ChElementBase.

## ◆ ComputeInternalJacobians()

void chrono::fea::ChElementShellANCF_3423::ComputeInternalJacobians | ( | double | Kfactor,
|  | double | Rfactor )

Compute Jacobians of the internal forces.

This function calculates a linear combination of the stiffness (K) and damping (R) matrices, J = Kfactor * K + Rfactor * R for given coefficients Kfactor and Rfactor. This Jacobian will be further combined with the global mass matrix M and included in the global stiffness matrix H in the function ComputeKRMmatricesGlobal().

## ◆ ComputeKRMmatricesGlobal()

void chrono::fea::ChElementShellANCF_3423::ComputeKRMmatricesGlobal | ( | ChMatrixRef | H,
|  | double | Kfactor,
|  | double | Rfactor = 0,
|  | double | Mfactor = 0 )
| overridevirtual

Set H as the stiffness matrix K, scaled by Kfactor.

Optionally, also superimposes global damping matrix R, scaled by Rfactor, and mass matrix M, scaled by Mfactor. Matrices are expressed in global reference. Corotational elements can take the local Kl & Rl matrices and rotate them.

Implements chrono::fea::ChElementBase.

## ◆ ComputeMassMatrix()

void chrono::fea::ChElementShellANCF_3423::ComputeMassMatrix | ( |  | ) |

Compute the mass matrix of the element.

Note: in this 'basic' implementation, constant section and constant material are assumed

## ◆ ComputeMmatrixGlobal()

void chrono::fea::ChElementShellANCF_3423::ComputeMmatrixGlobal | ( | ChMatrixRef | M | ) |
| overridevirtual

Set M as the global mass matrix.

Reimplemented from chrono::fea::ChElementGeneric.

## ◆ ComputeNF() [1/2]

void chrono::fea::ChElementShellANCF_3423::ComputeNF | ( | const double | U,
|  | const double | V,
|  | ChVectorDynamic<> & | Qi,
|  | double & | detJ,
|  | const ChVectorDynamic<> & | F,
|  | ChVectorDynamic<> * | state_x,
|  | ChVectorDynamic<> * | state_w )
| overridevirtual

Evaluate N'*F , where N is some type of shape function evaluated at U,V coordinates of the surface, each ranging in -1..+1 F is a load, N'*F is the resulting generalized load Returns also det[J] with J=[dx/du,..], that might be useful in gauss quadrature.

For this ANCF element, only the first 6 entries in F are used in the calculation. The first three entries is the applied force in global coordinates and the second 3 entries is the applied moment in global space.

Parameters

  U | parametric coordinate in surface
  V | parametric coordinate in surface
  Qi | Return result of Q = N'*F here
  detJ | Return det[J] here
  F | Input F vector, size is =n. field coords.
  state_x | if != 0, update state (pos. part) to this, then evaluate Q
  state_w | if != 0, update state (speed part) to this, then evaluate Q

Implements chrono::ChLoadableUV.

## ◆ ComputeNF() [2/2]

void chrono::fea::ChElementShellANCF_3423::ComputeNF | ( | const double | U,
|  | const double | V,
|  | const double | W,
|  | ChVectorDynamic<> & | Qi,
|  | double & | detJ,
|  | const ChVectorDynamic<> & | F,
|  | ChVectorDynamic<> * | state_x,
|  | ChVectorDynamic<> * | state_w )
| overridevirtual

Evaluate N'*F , where N is some type of shape function evaluated at U,V,W coordinates of the volume, each ranging in -1..+1 F is a load, N'*F is the resulting generalized load Returns also det[J] with J=[dx/du,..], that might be useful in gauss quadrature.

For this ANCF element, only the first 6 entries in F are used in the calculation. The first three entries is the applied force in global coordinates and the second 3 entries is the applied moment in global space.

Parameters

  U | parametric coordinate in volume
  V | parametric coordinate in volume
  W | parametric coordinate in volume
  Qi | Return result of N'*F here, maybe with offset block_offset
  detJ | Return det[J] here
  F | Input F vector, size is = n.field coords.
  state_x | if != 0, update state (pos. part) to this, then evaluate Q
  state_w | if != 0, update state (speed part) to this, then evaluate Q

Implements chrono::ChLoadableUVW.

## ◆ ComputeNodalMass()

void chrono::fea::ChElementShellANCF_3423::ComputeNodalMass | ( |  | ) |
| overridevirtual

Add contribution of element inertia to total nodal masses.

This class computes and adds corresponding masses to ElementGeneric member m_TotalMass.

Reimplemented from chrono::fea::ChElementBase.

## ◆ ComputeNormal()

ChVector3d chrono::fea::ChElementShellANCF_3423::ComputeNormal | ( | const double | U,
|  | const double | V )
| overridevirtual

Gets the normal to the surface at the parametric coordinate U,V.

Each coordinate ranging in -1..+1.

Implements chrono::ChLoadableUV.

## ◆ EvaluateSectionDisplacement()

void chrono::fea::ChElementShellANCF_3423::EvaluateSectionDisplacement | ( | const double | u,
|  | const double | v,
|  | ChVector3d & | u_displ,
|  | ChVector3d & | u_rotaz )
| overridevirtual

Gets the xyz displacement of a point on the shell, and the rotation RxRyRz of section reference, at parametric coordinates 'u' and 'v'.

Note, u=-1..+1 , v= -1..+1 parametric coordinates, except if triangular shell, where u=0..+1, v=0..+1, natural triangle coords. Results are not corotated.

Implements chrono::fea::ChElementShell.

## ◆ EvaluateSectionFrame()

void chrono::fea::ChElementShellANCF_3423::EvaluateSectionFrame | ( | const double | u,
|  | const double | v,
|  | ChVector3d & | point,
|  | ChQuaternion<> & | rot )
| overridevirtual

Gets the absolute xyz position of a point on the shell, and the absolute rotation of section reference, at parametric coordinates 'u' and 'v'.

Note, u=-1..+1 , v= -1..+1 parametric coordinates, except if triangular shell, where u=0..+1, v=0..+1, natural triangle coords. Results are corotated.

Implements chrono::fea::ChElementShell.

## ◆ EvaluateSectionPoint()

void chrono::fea::ChElementShellANCF_3423::EvaluateSectionPoint | ( | const double | u,
|  | const double | v,
|  | ChVector3d & | point )
| overridevirtual

Gets the absolute xyz position of a point on the shell, at parametric coordinates 'u' and 'v'.

Note, u=-1..+1 , v= -1..+1 parametric coordinates, except if triangular shell, where u=0..+1, v=0..+1, natural triangle coords. Results are corotated.

Implements chrono::fea::ChElementShell.

## ◆ EvaluateSectionStrainStress()

ChStrainStress3D chrono::fea::ChElementShellANCF_3423::EvaluateSectionStrainStress | ( | const ChVector3d & | loc,
|  | int | layer_id )

Return a struct with 6-component strain and stress vectors evaluated at a given quadrature point and layer number.

Beta

## ◆ EvaluateSectionVelNorm()

void chrono::fea::ChElementShellANCF_3423::EvaluateSectionVelNorm | ( | double | U,
|  | double | V,
|  | ChVector3d & | Result )
| overridevirtual

Virtual method to plot velocity field distribution.

Note, u=-1..+1 , v= -1..+1 parametric coordinates, except if triangular shell, where u=0..+1, v=0..+1, natural triangle coords.

Implements chrono::fea::ChElementShell.

## ◆ GetDensity()

double chrono::fea::ChElementShellANCF_3423::GetDensity | ( |  | ) |
| overridevirtual

This is needed so that it can be accessed by ChLoaderVolumeGravity.

Density is mass per unit surface.

Implements chrono::ChLoadableUVW.

## ◆ GetLoadableNumCoordsPosLevel()

virtual unsigned int chrono::fea::ChElementShellANCF_3423::GetLoadableNumCoordsPosLevel | ( |  | ) |
| inlineoverridevirtual

Gets the number of DOFs affected by this element (position part).

Implements chrono::ChLoadable.

## ◆ GetLoadableNumCoordsVelLevel()

virtual unsigned int chrono::fea::ChElementShellANCF_3423::GetLoadableNumCoordsVelLevel | ( |  | ) |
| inlineoverridevirtual

Gets the number of DOFs affected by this element (velocity part).

Implements chrono::ChLoadable.

## ◆ GetNode()

virtual std::shared_ptr< ChNodeFEAbase > chrono::fea::ChElementShellANCF_3423::GetNode | ( | unsigned int | n | ) |
| inlineoverridevirtual

Access the n-th node of this element.

Implements chrono::fea::ChElementBase.

## ◆ GetNodeNumCoordsPosLevel()

virtual unsigned int chrono::fea::ChElementShellANCF_3423::GetNodeNumCoordsPosLevel | ( | unsigned int | n | ) |
| inlineoverridevirtual

Get the number of coordinates from the n-th node used by this element.

Implements chrono::fea::ChElementBase.

## ◆ GetNodeNumCoordsPosLevelActive()

virtual unsigned int chrono::fea::ChElementShellANCF_3423::GetNodeNumCoordsPosLevelActive | ( | unsigned int | n | ) |
| inlineoverridevirtual

Get the number of active coordinates from the n-th node used by this element.

Reimplemented from chrono::fea::ChElementBase.

## ◆ GetNumCoordsPosLevel()

virtual unsigned int chrono::fea::ChElementShellANCF_3423::GetNumCoordsPosLevel | ( |  | ) |
| inlineoverridevirtual

Get the number of coordinates in the field used by the referenced nodes.

Implements chrono::fea::ChElementBase.

## ◆ GetNumCoordsPosLevelActive()

virtual unsigned int chrono::fea::ChElementShellANCF_3423::GetNumCoordsPosLevelActive | ( |  | ) |
| inlineoverridevirtual

Get the number of active coordinates in the field used by the referenced nodes.

Reimplemented from chrono::fea::ChElementBase.

## ◆ GetNumFieldCoords()

virtual unsigned int chrono::fea::ChElementShellANCF_3423::GetNumFieldCoords | ( |  | ) |
| inlineoverridevirtual

Number of coordinates in the interpolated field, ex=3 for a tetrahedron finite element or a cable, = 1 for a thermal problem, etc.

Implements chrono::ChLoadable.

## ◆ GetNumNodes()

virtual unsigned int chrono::fea::ChElementShellANCF_3423::GetNumNodes | ( |  | ) |
| inlineoverridevirtual

Get the number of nodes used by this element.

Implements chrono::fea::ChElementBase.

## ◆ GetNumSubBlocks()

virtual unsigned int chrono::fea::ChElementShellANCF_3423::GetNumSubBlocks | ( |  | ) |
| inlineoverridevirtual

Get the number of DOFs sub-blocks.

Implements chrono::ChLoadable.

## ◆ GetStateBlock()

void chrono::fea::ChElementShellANCF_3423::GetStateBlock | ( | ChVectorDynamic<> & | mD | ) |
| overridevirtual

Fill the D vector with the current field values at the nodes of the element, with proper ordering.

If the D vector has not the size of this->GetNumCoordsPosLevel(), it will be resized. {x_a y_a z_a Dx_a Dx_a Dx_a x_b y_b z_b Dx_b Dy_b Dz_b}

Implements chrono::fea::ChElementBase.

## ◆ GetSubBlockOffset()

virtual unsigned int chrono::fea::ChElementShellANCF_3423::GetSubBlockOffset | ( | unsigned int | nblock | ) |
| inlineoverridevirtual

Get the offset of the specified sub-block of DOFs in global vector.

Implements chrono::ChLoadable.

## ◆ GetSubBlockSize()

virtual unsigned int chrono::fea::ChElementShellANCF_3423::GetSubBlockSize | ( | unsigned int | nblock | ) |
| inlineoverridevirtual

Get the size of the specified sub-block of DOFs in global vector.

Implements chrono::ChLoadable.

## ◆ IsSubBlockActive()

virtual bool chrono::fea::ChElementShellANCF_3423::IsSubBlockActive | ( | unsigned int | nblock | ) | const
| inlineoverridevirtual

Check if the specified sub-block of DOFs is active.

Implements chrono::ChLoadable.

## ◆ LoadableGetStateBlockPosLevel()

void chrono::fea::ChElementShellANCF_3423::LoadableGetStateBlockPosLevel | ( | int | block_offset,
|  | ChState & | mD )
| overridevirtual

Gets all the DOFs packed in a single vector (position part).

Implements chrono::ChLoadable.

## ◆ LoadableGetStateBlockVelLevel()

void chrono::fea::ChElementShellANCF_3423::LoadableGetStateBlockVelLevel | ( | int | block_offset,
|  | ChStateDelta & | mD )
| overridevirtual

Gets all the DOFs packed in a single vector (velocity part).

Implements chrono::ChLoadable.

## ◆ LoadableGetVariables()

void chrono::fea::ChElementShellANCF_3423::LoadableGetVariables | ( | std::vector< ChVariables * > & | mvars | ) |
| overridevirtual

Get the pointers to the contained ChVariables, appending to the mvars vector.

Implements chrono::ChLoadable.

## ◆ LoadableStateIncrement()

void chrono::fea::ChElementShellANCF_3423::LoadableStateIncrement | ( | const unsigned int | off_x,
|  | ChState & | x_new,
|  | const ChState & | x,
|  | const unsigned int | off_v,
|  | const ChStateDelta & | Dv )
| overridevirtual

Increment all DOFs using a delta.

Implements chrono::ChLoadable.

## ◆ ShapeFunctions()

void chrono::fea::ChElementShellANCF_3423::ShapeFunctions | ( | ShapeVector & | N,
|  | double | x,
|  | double | y,
|  | double | z )

Fills the N shape function matrix.

NOTE! actually N should be a 3row, 24 column sparse matrix, as N = [s1*eye(3) s2*eye(3) s3*eye(3) s4*eye(3)...]; , but to avoid wasting zero and repeated elements, here it stores only the s1 through s8 values in a 1 row, 8 columns matrix!

## ◆ ShapeFunctionsDerivativeX()

void chrono::fea::ChElementShellANCF_3423::ShapeFunctionsDerivativeX | ( | ShapeVector & | Nx,
|  | double | x,
|  | double | y,
|  | double | z )

Fills the Nx shape function derivative matrix with respect to X.

NOTE! to avoid wasting zero and repeated elements, here it stores only the four values in a 1 row, 8 columns matrix!

## ◆ ShapeFunctionsDerivativeY()

void chrono::fea::ChElementShellANCF_3423::ShapeFunctionsDerivativeY | ( | ShapeVector & | Ny,
|  | double | x,
|  | double | y,
|  | double | z )

Fills the Ny shape function derivative matrix with respect to Y.

NOTE! to avoid wasting zero and repeated elements, here it stores only the four values in a 1 row, 8 columns matrix!

## ◆ ShapeFunctionsDerivativeZ()

void chrono::fea::ChElementShellANCF_3423::ShapeFunctionsDerivativeZ | ( | ShapeVector & | Nz,
|  | double | x,
|  | double | y,
|  | double | z )

Fills the Nz shape function derivative matrix with respect to Z.

NOTE! to avoid wasting zero and repeated elements, here it stores only the four values in a 1 row, 8 columns matrix!

## ◆ Update()

void chrono::fea::ChElementShellANCF_3423::Update | ( |  | ) |
| overridevirtual

Update the state of this element.

Reimplemented from chrono::fea::ChElementBase.

The documentation for this class was generated from the following files:

- D:/W/B/src/chrono-9.0.1/src/chrono/fea/ChElementShellANCF_3423.h
- D:/W/B/src/chrono-9.0.1/src/chrono/fea/ChElementShellANCF_3423.cpp